# Changelog

<!--
This file is autogenerated.
Only edit this file directly to correct typos.
See CONTRIBUTING.md for instructions on how new entries get added.
-->

This document contains a history of significant changes which have been released for `mbed-tools`. Please note that
beta releases are not included in this history. For a full list of all releases, please see the
[PyPI Release History](https://pypi.org/project/mbed-tools/#history).

[//]: # (begin_release_notes)

"3.4.0" (2020-10-12)
====================

Features
--------

- Add build command porcelain to build an Mbed project using CMake and Ninja. (#20200929104817)
- Replace assert-news with towncrier.check (#20201001170005)


Improved Documentation
----------------------

- Advise on using Tox rather than pipenv virtual environment (#202010091700)


Deprecations and Removals
-------------------------

- Remove consistency report checks (#202010091202)
- Remove install-development-dependencies.yml (#202010091203)
- Remove Pipfile (#202010091204)
- Remove pipenv from generate-target-database.yaml (#2020100812003)


Misc
----

- #202009291300, #202010061300, #202010091200, #202010091201, #2020100812000, #2020100812001, #2020100812002, #2020100812004, #20200925151500, #20200929160957


"3.3.0" (2020-09-17)
====================

Features
--------

- Add CMake variables for the selected printf and C library to the generated CMake module (#20200915)
- Add travis config file (#20200814183927)


Improved Documentation
----------------------

- Add create project, config and build instructions. (#202008211200)
- Update create project, example application and project environment instructions. (#202008251200)
- Add logging info. (#202008261300)


Misc
----

- #20200820131700, #20200820132210, #20200821142453


"3.2.2" (2020-08-19)
====================

Bugfixes
--------

- Remove MBED_BUILD_TIMESTAMP config option (#20200819144454)


Misc
----

- #20200817142518


"3.2.1" (2020-08-17)
====================

Bugfixes
--------

- Removing unused MBED_PROFILE, please use CMAKE_BUILD_TYPE to select a profile. (#20200813)
- Ensure program path is always made absolute on Windows. (#20200816123120)


"3.2.0" (2020-08-12)
====================

Features
--------

- Generate project startup files from init command (#20200810123455)


Bugfixes
--------

- Return an exit code of 1 when a ToolsError is raised (#20200729210710)
- Remove output path and use program root for configure command output (#20200805143228)
- Remove mbed-tools/project's dependency on the legacy .mbed file (#20200805210417)
- Process labels gathered from mbed_lib and mbed_app config files (#20200811095825)


Improved Documentation
----------------------

- add user docs (#20200730153335)
- Add install instructions and prerequisites (#20200811162038)


Misc
----

- #20200727201841, #20200729200627, #20200730145703, #20200805134310, #20200805160557


"3.1.2" (2020-07-29)
====================

Bugfixes
--------

- Remove gen_config interface library target from cmake template (#20200727143830)


"3.1.1" (2020-07-27)
====================

Bugfixes
--------

- Add manifest.in rule to upload all data files under the src dorectory (#20200727151049)


"3.1.0" (2020-07-27)
====================

Features
--------

- Create single package layout for mbed-tools (#20200722134138)


Improved Documentation
----------------------

- Add ADR for removing mbed_config.h (#20200723142705)


"3.0.1" (2020-07-20)
====================

Bugfixes
--------

- Pin mbed-build to ~1.2 (#20200720152641)


"3.0.0" (2020-07-20)
====================

Major changes
-------------

- Rename export to configure. (#20200717104411)


Features
--------

- Rename export-keys command to export (#20200701)


Bugfixes
--------

- Declare MIT license for zipp dependency (#20200701)


Improved Documentation
----------------------

- Add the minimal version requirement on pipenv (#20200709222031)


Misc
----

- #20200715101809


"2.1.0" (2020-04-30)
====================

Features
--------

- Add build command. (#20200430)


"2.0.0" (2020-04-29)
====================

Major changes
-------------

- Change export command name to be more accurate for the time being. (#20200416)


Features
--------

- Catch and log ToolsErrors in the CLI (#20200318)
- Use new context manager for handling tools errors and improved user friendly message about increasing verbosity (#20200403)
- Add export command to tools (#20200407)
- Added --version option to return versions of all Mbed packages (#20200422)
- Support added for Python 3.8 (#20200423)
- Add mbed-project commands (#20200427)
- Add conig command. (#20200428)
- Add config sub command (#2020031801)


Bugfixes
--------

- Sync with internal cookiecutter template (#20200317)
- Fixed spelling error (#20200408)
- Checked 3rd-party licences. (#20200427)


Improved Documentation
----------------------

- Added license headers for SPDX compliance. (#20200402)


Misc
----

- #20200316, #20200402, #20200420, #20200423, #20200427, #20200428


"1.0.0" (2020-03-06)
====================

Major changes
-------------

- Artificial release bump because of old mbed-tools (#20200207)


Features
--------

- Integrate mbed-devices (#20200207)


Misc
----

- #20200210
